/*======================================证件照检测======================================*/
package main

import (
	"bytes"
	"crypto/md5"
	"encoding/base64"
	"encoding/json"
	"fmt"
	"io/ioutil"
	"log"
	"net/http"
)

func ImgtoBase64Detect(filePath string) string {
	//图片转Base64
	bytes, err := ioutil.ReadFile(filePath)
	if err != nil {
		log.Fatal(err)
	}
	var base64Encoding string
	base64Encoding += base64.StdEncoding.EncodeToString(bytes)
	return base64Encoding
}

func MD5Detect(v string) string {
	d := []byte(v)
	m := md5.New()
	m.Write(d)
	b := m.Sum(nil)
	return base64.StdEncoding.EncodeToString([]byte(b))
}

func main() {
	appCode := "你的appcode"
	DetectUrl := "https://idpdetect.market.alicloudapi.com/idphoto/detect"

	client := &http.Client{}
	data := make(map[string]interface{})
	data["photo"] = ImgtoBase64Detect("1.jpg")
	data["photo_key"] = "" //"图片photo_key，证件照制作接口返回的值， photo和photo_key设置一个即可，如果两个都设置，则使用photo参数"

	bytesData, _ := json.Marshal(data)
	req, _ := http.NewRequest("POST", DetectUrl, bytes.NewReader(bytesData))
	req.Header.Set("Content-Type", "application/json")
	req.Header.Set("Authorization", "APPCODE "+appCode)

	md5Str := MD5Detect(string(bytesData))
	req.Header.Set("Content-MD5", md5Str)

	resp, _ := client.Do(req)
	fmt.Println(resp.Header)
	fmt.Println(resp.Header["X-Ca-Error-Message"])
	body, _ := ioutil.ReadAll(resp.Body)
	fmt.Println(string(body))

}
